package ${package};
import costo.kml2java.framework.*;
import costo.kml2java.framework.kmllibs.*;
import costo.kml2java.framework.channels.*;
import costo.kml2java.framework.annotations.*;
import static costo.kml2java.framework.kmllibs.KmeliaDefaultLib.*;

<#list imports?if_exists as import>
import ${import};
</#list>
/**
 *
 * @author costo kml2Java Generator
 * this code requires costo.kml2java.jar
 * 
 */

public  class ${name} extends <#if provided>ProvidedService<#else>RequiredService</#if> {
// component owner
protected ${owner} owner;



// protected ? 
//parameters
<#list parameters?if_exists as parameter>
@KmlElement(type={KmlElementType.PARAMETER})
protected ${parameter.modifiers} ${parameter.type} ${parameter.name};
@KmlElement(type={KmlElementType.PARAMETER})
public ${parameter.type} ${parameter.gettername}(){ return this.${parameter.name};}
</#list>

// protected ? 
<#list fields?if_exists as field>
@KmlElement(type={KmlElementType.VARIABLE})
${field.modifiers} ${field.type} ${field.name} <#if field.needsconstruction?if_exists>= new ${field.type}()</#if>  ;
@KmlElement(type={KmlElementType.VARIABLE})
public ${field.type} ${field.gettername}(){ return this.${field.name};}
</#list>

public void initLTS(){
<#if haslts>
${name}LTS lts=new ${name}LTS();
this.setLTS(lts);
lts.setService(this);
lts.init();
</#if>
}

public void initState(){
this.name="${servicename}";

<#list initfields?if_exists as init>
${init};
</#list> 
}

public void setOwner(${owner} cowner){
this.owner=cowner;
}


public ExecutableComponent getOwner(){
return this.owner;
}



// constants
<#list constants?if_exists as field>
@KmlElement(type={KmlElementType.CONSTANT})
${field.modifiers} ${field.type} ${field.name} <#if field.isconst> = ${field.value} </#if>;
</#list>



<#list methods?if_exists as method>
//${method.debug?if_exists}
 <#if debug?if_exists> log("${debug}");</#if>
${method.modifiers} ${method.returntype} ${method.signature}{
${method.body};
}
</#list>


public String toString(){
StringBuffer result=new StringBuffer("");
result.append(getOwner().getIdJFK());
result.append(".${name}: [");
<#list fields?if_exists as field>
result.append("${field.name}");
result.append(":");
result.append(${field.name});
<#if field_has_next>result.append(", ");</#if>
</#list>
result.append("]");
return result.toString();
}
@Override 
public String getStateSpace(){
return super.getStateSpace()+this.toString();
} 

public void setResult(Object param){
<#if return>Result=(${returntype}) param;</#if> 
}

public boolean isPreSatisfiedWithTheseParameters(Object[] params){
try{
<#list parameters?if_exists as parameter>
${parameter.name}= (${parameter.type})params[${parameter_index}] ;
</#list>
}catch (Exception e){
e.printStackTrace();
return false;
}

return  this.isPreConditionSatisfied();
}
<#if provided>
public  void executeStartingTransaction(){
Object[] rcvresult=this.receiveServiceCall("__CALLER","${servicename}",new Class<?>[]{<#list parameters?if_exists as parameter>
${parameter.type}.class<#if parameter_has_next>,</#if></#list>},this);
<#list parameters?if_exists as parameter>
${parameter.name}= (${parameter.type})rcvresult[${parameter_index}] ;
</#list>
}
</#if>




<#list transitionsmethods?if_exists as method>
//${method.debug?if_exists}
 <#if debug?if_exists> log("${debug}");</#if>
 @KmlElement(type={KmlElementType.TRANSITION})
${method.modifiers} ${method.returntype} ${method.signature}{
${method.body};
}
</#list>


}